//----------------------------------------------------------------------------------------------

// AppController.m  ShapefileToOpenClip

//----------------------------------------------------------------------------------------------

// Copyright (c) 2004-2009 Pascal Brandt - All Rights Reserved

/*
 
 
*/
//----------------------------------------------------------------------------------------------

#import "AppController.h"
#import "ShapeFileView.h"
#import "Shapefile.h"
#import <Cocoa/Cocoa.h>

@implementation AppController


- (void)awakeFromNib
{
  [nbrObjectsText setStringValue:@""];
  [zoomFactorText setStringValue:@""];
  //[nbrObjectsText setStringValue:@""];
  
}


- (long)nbrShapefiles
{
  return [mView nbrShapefiles];
};


- (void)displayNbrShapefiles
{
  NSString* theStr = [NSString stringWithFormat:@"%ld Shapefiles",[mView nbrShapefiles]];
  [nbrObjectsText setStringValue:theStr];
};


- (void)displayZoomFactor
{
  NSString* strZoom = [NSString stringWithFormat:@"%ld%%",(long)(lround(mView.zoom * 100))];
  [zoomFactorText setStringValue:strZoom];
}


- (IBAction)copyAsFeet:(id)sender
{
  //NSLog(@"AppController copyAsFeet");  // called
  [mView copyShapefiles:kFeet];
}


- (IBAction)copyAsMeters:(id)sender
{
  //NSLog(@"AppController copyAsMeters");  // called
  [mView copyShapefiles:kMeters];
}

/*
- (void)saveViewAs:(aSaveChoice)choice
{
  savePanel = [NSSavePanel savePanel];
  
  NSString* theTitle;
  NSString* theType;
  
  switch (choice) {
    case kSaveTIFF : theTitle = @"Save TIFF";
                     theType = @"tiff";
                     break;
    case kSavePDF  : theTitle = @"Save PDF";
                     theType = @"pdf";
                     break;
  };
  
  [savePanel setTitle:theTitle];
  
  NSString *delimiter = @",";
  //NSArray *array = [type componentsSeparatedByString:delimiter];
  NSArray *array = [theType componentsSeparatedByString:delimiter];
  [savePanel setAllowedFileTypes:array];
  
  [savePanel beginSheetModalForWindow:[mView window] completionHandler:^(NSInteger result) {

    NSData *image = 0;
    NSArray *arrayFileType = [savePanel allowedFileTypes];
    NSString *fileType = [arrayFileType componentsJoinedByString:@"\n"];
    //NSLog(@"fileType %@",fileType);  // fileType tiff
    
    // User did not click OK
    if(result == 0)
      return;
    
    switch (choice) {
      case kSaveTIFF : image = [mView TIFFForView];
                       break;
      case kSavePDF  : image = [mView PDFForView];
                       break;
    };
    
    
    if(image == 0) {
      NSRunAlertPanel(nil,@"Unknown file type '%@'",nil,nil,nil,fileType);
      return;
    }
    
    NSString *thePath = [[savePanel URL] path];
    //NSLog(@"thePath %@",thePath);  // /aaaTiff.tiff
    
    if([image writeToFile:thePath atomically:NO] == NO)
      NSRunAlertPanel(nil,@"Cannot save file '%@': %s",nil,nil,nil,thePath,strerror(errno));
    
  }];
  
};
*/

- (IBAction)open:(id)sender
{
  //NSLog(@"AppController open");
  [mView reset];
  //mView.zoom = 1.0;
  //[mView displayZoomFactor];
  
  __block NSOpenPanel *openPanel = [NSOpenPanel openPanel];
  
  NSArray *fileType = [NSArray arrayWithObject:@"shp"];
  //NSArray *TheFileTypes = [NSArray arrayWithObjects:@"shp",nil];
	
  //[openPanel setCanChooseDirectories:NO];
  [openPanel setAllowsMultipleSelection:YES];
  [openPanel setAllowedFileTypes:fileType];
  //[openPanel setMessage:@"Import one or more files."];

  [openPanel beginSheetModalForWindow:[mView window]
                    completionHandler:^(NSInteger result)
  {
    if (result == NSFileHandlingPanelOKButton) {

      NSArray* urls = [openPanel URLs];

      long LastN = urls.count - 1;

      for (long N = 0; N <= LastN; N++) {
        NSURL *ThisURL = [urls objectAtIndex:N];
        Shapefile *theShapefile = [[Shapefile alloc] initWithPath:[ThisURL path]];
        
        if (theShapefile)
          [mView addShapefile:theShapefile];
       
      }

      //[mView centerView];
      //[mView displayNbrShapefiles];
      [self displayNbrShapefiles];
      [mView setNeedsDisplay:YES];
    }

    openPanel = nil;
  }];
  
}

/*
- (IBAction)saveAsTiff:(id)sender
{
  //NSLog(@"AppController saveAsTiff");  // called
  [self saveViewAs:kSaveTIFF];
};
*/
/*
- (IBAction)saveAsPDF:(id)sender
{
  //NSLog(@"AppController saveAsPDF");  // called
  [self saveViewAs:kSavePDF];
};
*/

/*
- (NSData *)PDFForView:(NSView *)aView
{
	NSLog(@"AppController PDFForView");
  
  //NSRect rectToSave;
	//NSData *dataToSave;
	
	NSRect rectToSave = [aView bounds];
	NSData *dataToSave = [aView dataWithPDFInsideRect:rectToSave];
	
	return dataToSave;
	
}


- (NSData *)TIFFForView:(NSView *)aView
{
	NSLog(@"AppController TIFFForView");
  
  NSImage *image = [[NSImage alloc] initWithData:[self PDFForView:aView]];
	
	//[image autorelease];
	
	return [image TIFFRepresentation];

}
*/

@end
