//----------------------------------------------------------------------------------------------

// OpenClipUtils.h

//----------------------------------------------------------------------------------------------

// Copyright:	© 2014 by Sequoia Aircraft Corporation., all rights reserved.

#import <Cocoa/Cocoa.h>

double Radians2DegreesOpenClip(double Radians);
double Degrees2RadiansOpenClip(double Degrees);
NSPoint RadialNSPointOpenClip(NSPoint ThePt,double Angle,double Radius);
double Zeroto360OpenClip(double TheAngle);
double GetAngleOpenClip(NSPoint A,NSPoint B);


NSMutableDictionary* SetXYPointOpenClip(double X,double Y);
NSMutableDictionary* SetXYZPointOpenClip(double X,double Y,double Z);


BOOL GetScaleOpenClip(NSDictionary *TheDict,double *TheScale);
void SetScaleOpenClip(double TheScale,NSMutableDictionary *TheDict);

BOOL GetGlobalOriginOpenClip(NSDictionary *TheDict,NSPoint *TheOrigin);
void SetGlobalOriginOpenClip(double X,double Y,NSMutableDictionary *TheDict);

BOOL GetInsertionPointOpenClip(NSDictionary *TheDict,NSPoint *ThePt);
void SetInsertionPointOpenClip(double X,double Y,NSMutableDictionary *TheDict);

BOOL GetLayerNameOpenClip(NSDictionary *TheNSLayer,NSString *TheLayerName);

BOOL GetLayerColorOpenClip(NSDictionary *TheNSLayer,float *r,float *g,float *b,float *a);

BOOL GetLayerScaleOpenClip(NSDictionary *TheNSLayer,double *TheScale);

void SetObjectTypeOpenClip(NSString *TheType,NSMutableDictionary *TheObj);

BOOL Get2DPointOpenClip(NSArray *Points,int TheIndex,NSPoint *ThePt);
void AddXYPointOpenClip(double X,double Y,NSMutableArray *Points);

BOOL Get3DPointOpenClip(NSArray *Points,int TheIndex,NSPoint *ThePt,double *Z);
void AddXYZPointOpenClip(double X,double Y,double Z,NSMutableArray *Points);

void AddPointsToObjectOpenClip(NSMutableArray *Points,NSMutableDictionary *TheObj);

BOOL GetObjectZOpenClip(NSDictionary *TheObj,double *Z);
void SetObjectZOpenClip(double Z,NSMutableDictionary *TheObj);

BOOL GetObjectClosedOpenClip(NSDictionary *TheObj,BOOL *Closed);

NSMutableDictionary* RGBADictionaryOpenClip(RGBColor TheColor,double Alpha);
BOOL GetPenColorAndSetStrokeOpenClip(NSDictionary *TheObj);
void SetPenColorOpenClip(RGBColor PenColor,double PenAlpha,NSMutableDictionary *TheObj);

BOOL GetFillColorAndSetFillOpenClip(NSDictionary *TheObj);

BOOL GetPenSizeOpenClip(NSDictionary *TheObj,float *TheSize);

void GetLineDashAndSetPathDashOpenClip(NSDictionary *TheObj,NSBezierPath *ThePath);

BOOL GetRotationAngleOpenClip(NSDictionary *TheObj,double *TheAngle);

BOOL GetStartAngleOpenClip(NSDictionary *TheObj,double *TheAngle);

BOOL GetArcAngleOpenClip(NSDictionary *TheObj,double *TheAngle);

BOOL GetCornerRadiusOpenClip(NSDictionary *TheObj,double *TheRadius);

void WriteOutFileOpenClip(NSMutableDictionary *TheDocument);
void WriteToPasteboardOpenClip(NSMutableDictionary *TheDocument);