//----------------------------------------------------------------------------------------------

// ShapeFileView.h  ShapefileToOpenClip

//----------------------------------------------------------------------------------------------

// Copyright (c) 2004-2009 Pascal Brandt - All Rights Reserved

#import <Cocoa/Cocoa.h>
#import "Shapefile.h"
#import "ShapePoint.h"
#import "ShapePolyline.h"
#import "ShapefileList.h"

typedef enum {kMeters,kFeet} SHPunit;

@interface ShapeFileView : NSView
{
  ShapefileList*            mList;
  
  SHPunit                   mUnit;
  double                    mZoom;

  NSPrintInfo*              mPrintInfo;  // this is incomplete
  
  NSPoint                   mStartPoint;
}

@property(readwrite,assign)SHPunit unit;
@property(readwrite,assign)double zoom;


- (void)awakeFromNib;

- (void)reset;

- (BOOL)isOpaque;

- (void)addShapefile:(Shapefile*)thefile;

- (long)nbrShapefiles;
//- (void)displayNbrShapefiles;

- (void)print:(id)sender;

- (void)updateFrame;
- (void)setPrintInfo:(NSPrintInfo *)p;
- (NSPrintInfo *)printInfo;
- (void)updateChartSize:(NSNotification *)n;


- (void)setZoom:(double)thisZoom;

- (void)copyShapefiles:(SHPunit)theUnit;

- (void)drawShapefiles:(NSRect)rectBounds;

- (void)drawRect:(NSRect)rect;

//- (NSData*)PDFForView;
//- (NSData*)TIFFForView;

//- (void)displayZoomFactor;
- (void)zoomViewIn:(NSEvent*)theEvent;
- (void)zoomViewOut:(NSEvent*)theEvent;

- (void)scrollWheel:(NSEvent*)theEvent;

- (void)mouseDown:(NSEvent*)theEvent;
- (void)mouseDragged:(NSEvent*)theEvent;
- (void)mouseMoved:(NSEvent*)theEvent;
- (void)mouseUp:(NSEvent*)theEvent;

- (void)viewWillStartLiveResize;
- (void)viewDidEndLiveResize;

- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;

- (BOOL)acceptsFirstResponder;
- (BOOL)resignFirstResponder;
- (BOOL)becomeFirstResponder;

@end
