//----------------------------------------------------------------------------------------------

// Shapefile.h  ShapefileToOpenClip

//----------------------------------------------------------------------------------------------

// Copyright (c) 2004-2009 Pascal Brandt - All Rights Reserved

#import <Cocoa/Cocoa.h>

@interface Shapefile : NSObject
{
  NSRect           mBBox;
	
  SInt32           mFileLength;
  SInt32           mVersion;
  SInt32           mRecordCount;
  SInt32           mShapefileType;
	
//@public
	
  NSMutableArray*  mObjList;
  //double           mLineWidth;
	
}

@property (readwrite,assign) NSRect bbox;

@property (readwrite,assign) SInt32 fileLength;
@property (readwrite,assign) SInt32 recordCount;

@property (readwrite,assign) SInt32 shapefileType;

//@property (readwrite,assign) double lineWidth;

- (id)initWithPath:(NSString*)theFilePath;

- (NSString*)shapefileTypeAsString;
- (BOOL)badShapeType;


- (void*)parsePoint:(void*)pMain;
- (void*)parsePolyline:(void*)pMain;  // PolyLine and Polygon

- (BOOL)loadOneShapefile:(NSString*)theFilePath;

- (void)drawShapePoint:(NSAffineTransform*)t;
- (void)copyShapePoint:(NSAffineTransform*)t theList:(NSMutableArray *)TheList;
- (void)drawShapePolyline:(NSAffineTransform*)t;
- (void)copyShapePolyline:(NSAffineTransform*)t theList:(NSMutableArray *)TheList;


@end